import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Класс метки курсора поля. Обработка действий при изменении курсора мыши и клике.
 * 
 * @author Vladimir Gonchar, Roman Borisov, Sofiya Lichkovaha
 */
public class Crosshair extends Actor
{
    private boolean playerTurn = true;
    private int wow = 0;
    private bomb_on bombOn = new bomb_on();
    
    public void act() 
    {
        if (playerTurn) {
            mouseMoved();
            mouseClicked();
        }
    }

    public void mouseClicked() {
        if (Greenfoot.mouseClicked(this)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            Ship ship = getShip();
            if (ship != null) {
                if (!alreadyGuessed()) {
                    wow = 0;
                    getWorld().addObject(new Hit(), mouse.getX(), mouse.getY());
                    Greenfoot.delay(50);
                    ship.sink();
                    setPlayerTurn(false);
                }
            } else {
                if (!alreadyGuessed()) {
                    wow++;
                    getWorld().addObject(new Miss(), mouse.getX(), mouse.getY());
                    Greenfoot.delay(50);
                    setPlayerTurn(false);
                    
                    if(wow > 3){
                        getWorld().addObject(bombOn, 22, 2);
                    } else {
                        getWorld().removeObject(bombOn);
                    }
                }
            }
        }
    }

    public void mouseMoved() {
        if (Greenfoot.mouseMoved(null)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            int x = mouse.getX();
            int y = mouse.getY();
            if (((Battleship)getWorld()).inComputerGrid(x, y)) {
                setLocation(x, y);
            }
        }
    }

    public Ship getShip() {
        Ship ship = (Ship) getOneObjectAtOffset(0, 0, Ship.class);
        if (ship == null) {
            return null;
        }

        if (ship.isBlank(getX(), getY())) {
            return null;
        } else {
            return ship;
        }
    }
    
    public boolean alreadyGuessed() {
        return (getOneObjectAtOffset(0, 0, Guess.class) != null);        
    }
    
    public void setPlayerTurn(boolean turn) {
        playerTurn = turn;
    }
    
    public boolean isPlayerTurn() {
        return playerTurn;
    }
}
